using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.OleDb;
using ModuloComum;

namespace Telecomunicacoes
{
    internal class Chamada:IChamada
    {
        
        //#######################################
        //Implementao do Interface IChamada
        //#######################################
        #region IChamada Members

        TelecomunicacoesEnum.EnumGeral IChamada.RegistaChamada(string login, string password, string numeroInicio, string numeroDestino, int duracaoChamada, DateTime dataHoraInicio)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        TelecomunicacoesEnum.EnumGeral IChamada.IniciaChamada(string login, string password, string numeroOrigem, string numeroDestino, DateTime dataHoraInicio)
        {
            //Validar o utilizador na aplicao
            DataSet ds = new DataSet();
            object[] parametros = new object[] {
		  					"@login", OleDbType.WChar,login,
                            "@password",OleDbType.WChar,password,
		  					};
            ds=UtilBD.ExecuteDataSet("select count(*) as contador from tblUtilizadores where login=? and password=?", parametros);
            if (ds != null && ds.Tables.Count > 0 && ds.Tables[0].Rows.Count > 0)
            {
                if (Convert.ToInt32(ds.Tables[0].Rows[0][1].ToString()) > 0)
                {
                    //Verificar qual o carto associado e activo e o tarifrio associado
                    Cartao cartao = new Cartao();
                    //Metodo que devolve apenas os cartes activos
                    ds=cartao.ObterDetalhesCartaoActivo(numeroOrigem);
                    if (ds != null && ds.Tables.Count > 0 && ds.Tables[0].Rows.Count > 0)
                    {
                        //Verificar se  um carto recarregvel
                        if (ds.Tables[0].Rows[0]["tipoTarifario"].ToString() == "R")
                        {
                            double valorSaldoActual;
                            valorSaldoActual = Convert.ToDouble(ds.Tables[0].Rows[0]["saldoActual"].ToString());
                            if (valorSaldoActual > 0)
                            {
                                return TelecomunicacoesEnum.EnumGeral.OPERACAO_REALIZADA_COM_SUCESSO;
                            }
                            else
                                return TelecomunicacoesEnum.EnumGeral.OPERACAO_REALIZADA_COM_INSUCESO;

                        }
                        else
                        {
                            //Carto do TipoAssinatura
                            //Como se trata de um carto do tipo assinatura pode iniciar a chamada desde que o carto no esteja cancelado.

                        }
                    }
                    else
                    {
                        return TelecomunicacoesEnum.EnumGeral.OPERACAO_REALIZADA_COM_INSUCESO;
                    }
                    return TelecomunicacoesEnum.EnumGeral.OPERACAO_REALIZADA_COM_INSUCESO;
                }
                else
                {
                    return TelecomunicacoesEnum.EnumGeral.UTILIZADOR_INVALIDO;
                }
            }
            else
            {
                return TelecomunicacoesEnum.EnumGeral.UTILIZADOR_INVALIDO;
            }
            
            
            
        }

        TelecomunicacoesEnum.EnumGeral IChamada.FinalizaChamada(string login, string password, string numeroOrigem, DateTime dataHoraFim)
        {
            throw new Exception("O mtodo FinalizaChamada no est implementado.");
        }

        #endregion
        //##########################################
        //Fim de Implementao do Interface IChamada
        //##########################################


        //######################
        //Mtodos internos
        //######################
        #region Metodos Internos
        /// <summary>
        /// Mtodo interno que permite obter o tarifrio associado a um determinado nmero.
        /// </summary>
        /// <param name="numeroTelemovel">Nmero de telemvel para o qual se pretende fazer a pesquisa</param>
        /// <returns>Enumerrio que indica se o nmero existe ou no no sistema, se existe qual o tipo de tarifrio associado.</returns>
        private TelecomunicacoesEnum.EnumGeral ObterTarifarioNumero(string numeroTelemovel)
        {
            throw new Exception("O mtodo obter Tarifrio ainda no foi implementado.");

        }
        private int ObterTempoRestante(string numeroTelemovel, string numeroDestino)
        {
            throw new Exception("O mtodo obter Tarifrio ainda no foi implementado.");
        }
        private TelecomunicacoesEnum.EnumGeral RegistaInicioChamada(string numeroOrigem,string numeroDestino,DateTime InstanteInicio)
        {
            //Verificar se o n j etem alguma chamada iniciada para o n em causa
            DataSet ds = new DataSet();
            object[] parametros = new object[] {
		 					"@numeroAssociado", OleDbType.Char, numeroOrigem,			
		  					};
            string strSql = "";
            strSql = "select tblCartoes.codCartao,tblCartoes.codCliente,tblCartoes.numeroTelefoneAssociado,tblCartoes.dataEmissao ";
            strSql = strSql + "tblCartoes.saldoActual,tblCartoes.Cancelado,tblCartoes.tarifario,tblTarifarios.tipoTarifario " ;
            strSql = strSql + " from tblCartoes inner join tblTarifarios on tblCartoes.tarifario=tbltarifarios.codTarifario inner ";
            strSql = strSql + "join tblComunicacoesEfectuadas on tblCartoes.codCartao=tblComunicacoesEfectuadas.codCartao ";
            strSql = strSql + "where tblComunicacoesEfecuadas.activa=true and tblCartoes.numeroAssociado=?";


            ds = UtilBD.ExecuteDataSet(strSql, parametros);
            if (ds != null && ds.Tables.Count > 0 && ds.Tables[0].Rows.Count > 0)
            {
                return TelecomunicacoesEnum.EnumGeral.OPERACAO_REALIZADA_COM_INSUCESO;
            }
            else 
            {
                //Fazer o registo de inicio de chamada
                strSql = "insert into tblTelecomunicacoesEfectuadas(codTarifario,activo,instanteInicio,instanteFim,numeroOrigem,numeroDestino,precoPorSegundotipoComunicacao) values("+".."+")";
                strSql = strSql + "tblCartoes.saldoActual,tblCartoes.Cancelado,tblCartoes.tarifario,tblTarifarios.tipoTarifario " ;
                strSql = strSql + " from tblCartoes inner join tblTarifarios on tblCartoes.tarifario=tbltarifarios.codTarifario inner ";
                strSql = strSql + "join tblComunicacoesEfectuadas on tblCartoes.codCartao=tblComunicacoesEfectuadas.codCartao ";
                strSql = strSql + "where tblComunicacoesEfecuadas.activa=true and tblCartoes.numeroAssociado=?";

            }
            return TelecomunicacoesEnum.EnumGeral.OPERACAO_REALIZADA_COM_INSUCESO;
                
        }
        /// <summary>
        /// Mtodo responsvel por fazer o calculo do custo total da chamada
        /// o pre
        /// </summary>
        /// <param name="numeroOrigem">Nmero de origem da chamada.</param>
        /// <param name="numeroDestino">Nmero de destino da chamada</param>
        /// <param name="instanteInicio">Instante inicial em que iniciou a chamada.</param>
        /// <param name="instanteFim">Instante final, instante em que terminou a chamada</param>
        /// <returns></returns>
        private double CalculaValorTotalChamada(string numeroOrigem, string numeroDestino, DateTime instanteInicio,DateTime instanteFim)
        {
            return -1;
 
        }
        #endregion

    }
}
