using System;
using System.Collections.Generic;
using System.Text;
using ModuloComum;

namespace Telecomunicacoes
{
    /// <summary>
    /// Classe que implementa os mtodos disponibilizados interface IFactory
    /// </summary>
    public sealed class Factory
    {
        /// <summary>
        /// Mtodo construtor sem parmetros da classe factory
        /// </summary>
        private Factory()
        {
        }
        /// <summary>
        /// Este mtodo  o responsvel por implementar o acesso ao servio Utilizador
        /// </summary>
        /// <returns></returns>
        public static IUtilizador CriaServicoUtilizador()
        {
            return new Utilizador();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public static ICartao CriaServicoCartao()
        {
            return new Cartao();
        }
        public static IChamada CriaServicoChamada()
        {
            return new Chamada();
        }
        public static ICliente CriaServicoCliente()
        {
            return new Cliente();
        }
        public static ITarifario CriaServicoTarifario()
        {
            return new Tarifario();
        }
    }
}
