using System;
using System.Collections.Generic;
using System.Text;
using ModuloComum;

namespace Telecomunicacoes
{
    public interface IChamada
    {
        /// <summary>
        /// Mtodo que permite alterantivammente registar o incio e fim da chamada.
        /// </summary>
        /// <param name="login">Login do utilizador corrente</param>
        /// <param name="password">Password do utilizador corrente</param>
        /// <param name="numeroInicio">Nmero que iniciou a chamada</param>
        /// <param name="numeroDestino">Nmero ao qual se destina a chamada.</param>
        /// <param name="duracaoChamada">Durao da chamada em segundos</param>
        /// <param name="dataHoraInicio">Data e Hora de Inicio para efeitos de registo</param>
        /// <returns>Um enmerrio que indica do sucesso ou insucesso da operao descrevendo em caso de insucesso o que provocou essa falha.</returns>
        TelecomunicacoesEnum.EnumGeral RegistaChamada(string login, string password, string numeroInicio, string numeroDestino,int duracaoChamada, DateTime dataHoraInicio);

        /// <summary>
        /// Mtodo que permite Iniciar uma chamada.
        /// </summary>
        /// <param name="login">Login do utilizador corrente para efeitos de autenticao</param>
        /// <param name="password">Password do utilizador corrente para efeitos de autenticao</param>
        /// <param name="numeroOrigem">Nmero de origem</param>
        /// <param name="numeroDestino">Nmero de destino</param>
        /// <param name="dataHoraInicio">Data e hora de incio da chamada</param>
        /// <returns>Enumerrio que indica no s o sucesso ou insucesso da operao bem como se o cliente tem ou no saldo e se lhe  permitido ou no efectuar a chamda.</returns>
        TelecomunicacoesEnum.EnumGeral IniciaChamada(string login, string password, string numeroOrigem, string numeroDestino, DateTime dataHoraInicio);
        /// <summary>
        /// Mtodo que permite fazer a finalizao de uma chamada 
        /// </summary>
        /// <param name="login">Login do utilizador corrente para efeitos de autenticao</param>
        /// <param name="password">Password do utilizador corrente para efeitos de autenticao.</param>
        /// <param name="numeroOrigem">Nmero que est a fazer a chamada.</param>
        /// <param name="dataHoraFim">Data e Hora de Fim de chamada.</param>
        /// <returns>Enumerrio que indica se a opero bem sucedida ou no.</returns>
        TelecomunicacoesEnum.EnumGeral FinalizaChamada(string login, string password, string numeroOrigem, DateTime dataHoraFim);


    }
}
