using System;
using System.Collections.Generic;
using System.Text;
using ModuloComum;

namespace Telecomunicacoes
{
    public interface ITarifario
    {
        //*******************
        //
        /// <summary>
        /// Mtodo que permite criar um novo plano tarifrio. 
        /// </summary>
        /// <param name="login">Login para efeitos de validao do utilizador no mtodo.</param>
        /// <param name="password">Password para efeitos de autenticao do utilizador neste mtodo.</param>
        /// <param name="DetalheTarifario">DataSet que deve obdecer s definies do DataSet retornado pelos mtodos 
        /// ObterTarifario() e ObterDetalheTarifario().</param>
        /// <returns>Enumerrio que indica o sucesso ou insucesso da operao.</returns>
        TelecomunicacoesEnum.EnumGeral CriarPlanoTarifario(string login, string password, System.Data.DataSet DetalheTarifario);
        /// <summary>
        /// Mtodo que permite alterar um plano tarifrio. Este plano tarifrio pode ser alterado 
        /// </summary>
        /// <param name="login">Login do utilizador corrente para efeitos de autenticao no mtodo.</param>
        /// <param name="password">Password para validao do utilizador corrente.</param>
        /// <param name="codigoTarifario">Cdigo do tarifrio que se pretende alterar.</param>
        /// <param name="DetalheTarifario">DataSet que contm os dados necessrios para alterao do tarifrio. Este DataSet deve obdecer ao
        ///  estrutura retornada pelos mtodos ObterTarifario() e ObterDetalheTarifario()deste interface.</param>
        /// <returns>Enumerrio que indica o resultado do sucesso ou insucesso da operao.</returns>
        TelecomunicacoesEnum.EnumGeral AlterarPlanoTarifario(string login, string password, int codigoTarifario, System.Data.DataSet DetalheTarifario);
        /// <summary>
        /// Mtodo que permite obter um DataSet com as tabelas para preenchimento com o Tarifrio complecto.
        /// </summary>
        /// <returns>Devolve um DataSet com a estrutura destinada ao preenchimento dos vrios items associados a um tarifrio.</returns>
        System.Data.DataSet ObterTarifario(string login,string password, int codigoTarifario);
        /// <summary>
        /// Mtodo que permite obter um DataSet com um detalhe de tarifrio destinado a um posterior preenchimento para operaes de insero e de alterao de  detalhes de tarifrio.
        /// </summary>
        /// <returns>DataSet contendo a estrutura destinada  insero / alterao de um detalhe de um tarifrio.</returns>
        System.Data.DataSet ObterDetalheTarifario(string login, string password, int codigoTarifario);
        /// <summary>
        /// Mtodo que disponibiliza uma lista de tarifrios que existem no sistema.
        /// </summary>
        /// <param name="login">login do utilizador corrente para efeitos de autenticao no sistema</param>
        /// <param name="password">password do utilizador correntes para efietos de autenticao no sistema</param>
        /// <returns>DataSet que contm os tarifrios</returns>
        System.Data.DataSet ObterTarifarios(string login, string password);
        

    }
}
