using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using ModuloComum;

namespace Telecomunicacoes
{
    internal class Tarifario:ITarifario
    {
        //Deve-se verificar se os utilizadores que usam a criao e alterao de tarifrios se so 
        //supervisores
        #region ITarifario Members

        TelecomunicacoesEnum.EnumGeral ITarifario.CriarPlanoTarifario(string login, string password, System.Data.DataSet DetalheTarifario)
        {
            //Verificar se o utilizador  um supervisor
            Utilizador utilizador = new Utilizador();
            if (utilizador.ValidaUtilizador(login, password) != TelecomunicacoesEnum.EnumGeral.UTILIZADOR_SUPERVISOR)
            {
                return TelecomunicacoesEnum.EnumGeral.UTILIZADOR_INVALIDO;
            }
            else
            {
                if (DetalheTarifario != null && DetalheTarifario.Tables.Count== 0 && DetalheTarifario.Tables[0].Rows.Count > 0)
                {
                    try
                    {
                        //Percorrer o DataSet e tentar armazenar os dados

                    }
                    catch (Exception)
                    {

                    }
                }
                else
                    return TelecomunicacoesEnum.EnumGeral.OPERACAO_REALIZADA_COM_SUCESSO;
            }

            throw new Exception("The method or operation is not implemented.");
        }

        TelecomunicacoesEnum.EnumGeral ITarifario.AlterarPlanoTarifario(string login, string password, int codigoTarifario, DataSet DetalheTarifario)
        {
           //Verificar se o login  e password autnticam um utilizador do Tipo SuperVisor
            Utilizador utilizador = new Utilizador();
            if (utilizador.ValidaUtilizador(login, password) != TelecomunicacoesEnum.EnumGeral.UTILIZADOR_SUPERVISOR)
            {
                return TelecomunicacoesEnum.EnumGeral.UTILIZADOR_INVALIDO;
            }
            else
            {
                //Verificar se o cdigo do Tarifrio existe no sistema
                DataSet ds = new DataSet();
                object[] parametros = new object[] {
		  					"@codTarifario", System.Data.OleDb.OleDbType.Integer,codigoTarifario.ToString(),
		  					};
                ds = UtilBD.ExecuteDataSet("select codTarifario from tblTarifarios where codTarifario=?", parametros);
                if (ds != null && ds.Tables.Count > 0 && ds.Tables[0].Rows.Count > 0)
                {
                    
                    //O tarifrio existe, pode-se proceder  alterao depois de verificada a validade dos 
                    //dados do dataset do detalhe
                    
                    //O DataSet deve ter uma estrutura em tudo semelhante ao da tabela que vai guardar os dados

                    throw new Exception("Zona do cdigo ainda no implementada, o cdigo do tarifrio existe....");

                }
                else
                {
                    return TelecomunicacoesEnum.EnumGeral.OPERACAO_REALIZADA_COM_INSUCESO;
                }
                

            }
            
        }
        System.Data.DataSet ITarifario.ObterDetalheTarifario(string login, string password, int codigoTarifario)
        {
            Utilizador utitilizador = new Utilizador();
            TelecomunicacoesEnum.EnumGeral resultado;
            resultado = utitilizador.ValidaUtilizador(login, password);
            object [] parametros= new object[] {
		  					"@codTarifario", System.Data.OleDb.OleDbType.Integer,codigoTarifario.ToString(),
		  					};
            if (resultado != TelecomunicacoesEnum.EnumGeral.UTILIZADOR_INVALIDO)
            {
                StringBuilder strSql = new StringBuilder();
                strSql.Append("select tblTarifarios.codTarifario,tblTarifarios.tipoTarifario,tblTarifarios.descricao,");
                strSql.Append("tblTarifarios.dataInicioTarifario,tblTarifarios.valorComissao,tarifarioSemana,indicativoRedeDestino,redeFixa,periodo,custo,horaInicio");
                strSql.Append(" from TblTarifarios inner join tbltarifarioDetalhe on tblTarifarioDetalhe.codtarifario=tblTarifarios.codTarifario");
                strSql.Append(" where tblTarifarios.codTarifario=?");
                return UtilBD.ExecuteDataSet(strSql.ToString(), parametros);
            }
            else
                return null;

            //throw new Exception("The method or operation is not implemented.");
        }
        System.Data.DataSet ITarifario.ObterTarifarios(string login, string password)
        {
            Utilizador utitilizador = new Utilizador();
            TelecomunicacoesEnum.EnumGeral resultado;
            resultado = utitilizador.ValidaUtilizador(login, password);
            if (resultado!=TelecomunicacoesEnum.EnumGeral.UTILIZADOR_INVALIDO)
                return UtilBD.ExecuteDataSet("select codTarifario,tipoTarifario,descricao,dataInicioTarifario,valorComissao from TblTarifarios",null);
            else
                return null;
            
        }


        #endregion
    }
}
